%{!?kernel: %{expand: %%define kernel %(uname -r)}}
%define	kversion %(echo %{kernel} | sed -e 's/(bigmem|smp)$//' -)

Summary:        IBM ThinkPad support kernel modules
Name:           kernel-module-thinkpad
Version:        4.4
Release:        0.fdr.1
Epoch:          0
License:        GPL
Group:          System Environment/Kernel
URL:            http://tpctl.sourceforge.net/
Source0:        http://ftp.debian.org/debian/pool/main/t/thinkpad/thinkpad_4.4.orig.tar.gz
Source1:        %{name}.README.modules.conf
Source2:        %{name}.makedev
Source3:        %{name}.find-cflags
Patch0:         %{name}.rpm.patch
BuildRequires:  kernel-source = 0:%{kversion}, kernel-source >= 0:2.4.19
BuildRequires:  MAKEDEV
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
ExclusiveArch:  i586 i686

%description
IBM ThinkPad support kernel modules.

You may recompile this package for a given kernel version and arch with:
--define "kernel <uname -r output>"
(for example "kernel 2.4.20-5")
--target <arch>

%package %{kversion}
Summary:        %{summary}
Group:          System Environment/Kernel
Provides:       kernel-module
Provides:       %{name} = %{epoch}:%{version}-%{release}
Obsoletes:      kernel-mod-thinkpad
Requires:       kernel = 0:%{kversion}
Requires(pre):  modutils

%description %{kversion}
IBM ThinkPad support kernel modules.  Please see README.modules.conf
in the package documentation directory for instructions for enabling
the modules.

# -----------------------------------------------------------------------------

%prep
%setup -q -n thinkpad-%{version}
%patch0 -p1
# Arrange the sources so that we'll be building from the correct ones.
mkdir 2.5
mv drivers include 2.5
KMAJOR=$(echo %{kversion} | cut -b 0-3)
ln -s $KMAJOR/drivers drivers
ln -s $KMAJOR/include include

# -----------------------------------------------------------------------------

%build

# Find out the target kernel CFLAGS.
pushd /lib/modules/%{kernel}/build
KCFLAGS=`sh %{SOURCE3} %{_target_cpu}`
popd

make %{?_smp_mflags} all KSRC=/lib/modules/%{kernel}/build KCFLAGS="$KCFLAGS"
cp -p %{SOURCE1} ./README.modules.conf

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

make install_modules \
  DIR_MOD=$RPM_BUILD_ROOT/lib/modules \
  DIR_MOD_VER=$RPM_BUILD_ROOT/lib/modules/%{kernel} \
  DIR_MODULES_VER=$RPM_BUILD_ROOT/lib/modules/%{kernel}

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man4
cp -p man/*.4 $RPM_BUILD_ROOT%{_mandir}/man4

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d/thinkpad

/dev/MAKEDEV \
  -c $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d \
  -d $RPM_BUILD_ROOT/dev -M thinkpad | sed "s|$RPM_BUILD_ROOT||g" \
  > %{name}.files

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%pre %{kversion}
groupadd -r thinkpad >/dev/null 2>&1 || :

%post %{kversion}
depmod -a -F /boot/System.map-%{kversion} %{kversion} >/dev/null 2>&1 || :

%postun %{kversion}
depmod -a -F /boot/System.map-%{kversion} %{kversion} >/dev/null 2>&1 || :

# -----------------------------------------------------------------------------

%files %{kversion} -f %{name}.files
%defattr(0644,root,root,0755)
%doc AUTHORS ChangeLog COPYING README* SUPPORTED-MODELS TECHNOTES
/lib/modules/%{kernel}/thinkpad
%{_mandir}/*/*
%config %{_sysconfdir}/makedev.d

# -----------------------------------------------------------------------------

%changelog
* Sat May 17 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.4-0.fdr.1
- Update to 4.4 (from Debian).
- Un-hardwire 2.4.x build.
- Use proper kernel CFLAGS.
- Require specific kernel version.
- Use /dev/MAKEDEV for creating the device node, and own it.
- %%{buildroot} -> $RPM_BUILD_ROOT.
- Post(un)install scriptlet cleanups.

* Fri Apr 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.4
- Actually build for a 2.4.x kernel, hardwired for now (#214).

* Mon Apr 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.3
- Rename to kernel-module-thinkpad.
- Obsolete kernel-mod-thinkpad.
- Add ExclusiveArch: i586 i686.
- Fix missing epoch in kernel-source dependency.

* Mon Apr  7 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.2
- Actually include README.modules.conf (#8 comment 13).

* Sat Apr  5 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:4.3-0.fdr.1
- Update to 4.3.
- More spec file cleanups.

* Mon Mar 31 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.7-0.fdr.3
- Small spec cleanups.

* Sun Mar 30 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.7-0.fdr.2
- %%postun tricks for better cleanup after erase.

* Thu Mar 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:3.7-0.fdr.1
- Updated according to Fedora naming guidelines RC3.

* Sun Feb 23 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.4
- Proof-of-concept for new kernel module packaging guideline proposal.
- Create group and /dev/thinkpad only on new install.
- Renamed to thinkpad-kernel.

* Sun Feb 23 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.3
- Do install_modules instead of install in %%install to avoid unnecessary
  modprobing (#8).

* Sat Feb 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.2
- Add support for %%kernel define.

* Sat Feb  8 2003 Ville Skyttä <ville.skytta at iki.fi> - 3.7-1.fedora.1
- First Fedora release.
